<?php
/*
// requires Wordpress 2.8.0 or greater

Plugin Name: Wordpress Lockdown
Plugin URI: http://wordpresslockdown.com
Description: Automatically monetize your Amember or Clickbank Wordpress site with [protect] tags in your posts that only allow paying visitors access to posts. Integrates with both Clickbank and Amember to restrict posts based on products they've bought. Also works based on Wordpress user level.
Version: 1.0
Author: http://wordpresslockdown.com
Author URI: http://wordpresslockdown.com

Copyright 2008 Matt Jones. All Rights Reserved
*/

require_once ( ABSPATH . WPINC . '/registration.php' );

add_action('admin_menu', 'lockdownOptions');

function lockdownOptions()
  {
  if(function_exists('add_options_page'))
    add_options_page('Wordpress Lockdown Options', 'Wordpress Lockdown', 10, 'WordpressLockdown/options.php');
  }

//echo "<hr>ABSPATH=".ABSPATH."<hr>";

include_once(ABSPATH.'wp-config.php');
include_once(ABSPATH.'wp-includes/wp-db.php');

add_filter('the_content', 'lockdown', 0);

if(!isset($_SESSION))
  session_start();
    
function lockdown($content)
  {
  include('loadOptions.php');

/*
  echo "<hr><b>_amember_products</b>";
  foreach($_SESSION['_amember_products'] as $key=>$val)
    echo "<li>".$key."=".$val;
*/
/*
  echo "<hr><b>_amember_product_ids</b>";
  foreach($_SESSION['_amember_product_ids'] as $key=>$val)
    echo "<li>".$key."=".$val;
*/
/*
  echo "<hr><b>_amember_products0add_urls</b>";
  foreach($_SESSION['_amember_products'][1]['add_urls'] as $key=>$val)
    echo "<li>".$key."=".$val;
*/
/*
  echo "<hr><b>_amember_links</b>";
  foreach($_SESSION['_amember_links'] as $key=>$val)
    echo "<li>".$key."=".$val;
*/
/*
  echo "<hr><b>_amember_links6</b>";
  foreach($_SESSION['_amember_links'][6] as $key=>$val)
    echo "<li>".$key."=".$val;
*/
/*
  echo "<hr><b>Session</b>";
  foreach($_SESSION as $key=>$val)
    echo "<li>".$key."=".$val;
//*/

  $lockdownStart=strpos($content, '[protect]');             

  // If has no lockdown tag, exit quickly
  if($lockdownStart===false)
    {
    if($wpl_debugMode)
      {
      if($wpl_stealthDebug) echo "\n<!--";
      echo "\n".'<p><b style="color: #d00">Allowing access because the post has no [protect] tag</b></p>';
      if($wpl_stealthDebug) echo "\n-->";
      }
    
    return $content;
    }

  $lockdownEnd=strpos($content, '[/protect]', $lockdownStart); 
  
  $lockedDownText=substr($content, $lockdownStart+strlen('[protect]'), $lockdownEnd-$lockdownStart-strlen('[/lockdown]')+1); // extract lockdown text
  $freeContent=substr($content, 0, $lockdownStart);
  $endContent=substr($content, $lockdownEnd+strlen('[/protect]'), strlen($content)); // strip lockdown text from lockedDownText
    
  $teaseStart=strpos($lockedDownText, '[teaser]');             
  $teaseEnd=strpos($lockedDownText, '[/teaser]', $teaseStart); 

  // If has tease tag
  if($teaseStart!==false)
    {
    $wpl_teaseText=substr($lockedDownText, $teaseStart+strlen('[teaser]'), $teaseEnd-$teaseStart-strlen('[/teaser]')+1); // extract tease text
    $wpl_teaseText=trim($wpl_teaseText);
    $lockedDownText=substr($lockedDownText, 0, $teaseStart) . substr($lockedDownText, $teaseEnd+strlen('[/teaser]'), strlen($lockedDownText)); // strip tease text from lockedDownText
    }

  $wpl_buttonUrlStart=strpos($lockedDownText, '[url]');             
  $wpl_buttonUrlEnd=strpos($lockedDownText, '[/url]', $wpl_buttonUrlStart); 

  // If has url tag
  if($wpl_buttonUrlStart!==false)
    {
    $wpl_buttonUrl=substr($lockedDownText, $wpl_buttonUrlStart+strlen('[url]'), $wpl_buttonUrlEnd-$wpl_buttonUrlStart-strlen('[/url]')+1); // extract wpl_buttonUrl text
    $wpl_buttonUrl=trim($wpl_buttonUrl);
    $lockedDownText=substr($lockedDownText, 0, $wpl_buttonUrlStart) . substr($lockedDownText, $wpl_buttonUrlEnd+strlen('[/url]'), strlen($lockedDownText)); // strip wpl_buttonUrl text from lockedDownText
    }

  $buttonStart=strpos($lockedDownText, '[button]');             
  $buttonEnd=strpos($lockedDownText, '[/button]', $buttonStart); 

  // If has button tag
  if($buttonStart!==false)
    {
    $wpl_buttonText=substr($lockedDownText, $buttonStart+strlen('[button]'), $buttonEnd-$buttonStart-strlen('[/button]')+1); // extract button text
    $wpl_buttonText=trim($wpl_buttonText);
    $lockedDownText=substr($lockedDownText, 0, $buttonStart) . substr($lockedDownText, $buttonEnd+strlen('[/button]'), strlen($lockedDownText)); // strip button text from lockedDownText
    }

  $productsStart=strpos($lockedDownText, '[amember]');             
  $productsEnd=strpos($lockedDownText, '[/amember]', $productsStart); 
  
  // If has products tag
  if($productsStart!==false)
    {
    $wpl_amemberText=substr($lockedDownText, $productsStart+strlen('[amember]'), $productsEnd-$productsStart-strlen('[/amember]')+1); // extract products text
    $lockedDownText=substr($lockedDownText, 0, $productsStart) . substr($lockedDownText, $productsEnd+strlen('[/amember]'), strlen($lockedDownText)); // strip products text from lockedDownText
    }

  $userlevelStart=strpos($lockedDownText, '[userlevel]');             
  $userlevelEnd=strpos($lockedDownText, '[/userlevel]', $userlevelStart); 
  
  // If has userlevel tag
  if($userlevelStart!==false)
    {
    $wpl_userlevelText=substr($lockedDownText, $userlevelStart+strlen('[userlevel]'), $userlevelEnd-$userlevelStart-strlen('[/userlevel]')+1); // extract userlevel text
    $wpl_userlevelText=trim($wpl_userlevelText);
    $lockedDownText=substr($lockedDownText, 0, $userlevelStart) . substr($lockedDownText, $userlevelEnd+strlen('[/userlevel]'), strlen($lockedDownText)); // strip userlevel text from lockedDownText
    }

  $wpl_incrTitleStart=strpos($lockedDownText, '[incrTitle]');             
  $wpl_incrTitleEnd=strpos($lockedDownText, '[/incrTitle]', $wpl_incrTitleStart); 
  
  // If has wpl_incrTitle tag
  if($wpl_incrTitleStart!==false)
    {
    $wpl_incrTitleText=substr($lockedDownText, $wpl_incrTitleStart+strlen('[wpl_incrTitle]'), $wpl_incrTitleEnd-$wpl_incrTitleStart-strlen('[/wpl_incrTitle]')+1); // extract wpl_incrTitle text
    $wpl_incrTitle=trim($wpl_incrTitleText);
    $lockedDownText=substr($lockedDownText, 0, $wpl_incrTitleStart) . substr($lockedDownText, $wpl_incrTitleEnd+strlen('[/wpl_incrTitle]'), strlen($lockedDownText)); // strip wpl_incrTitle text from lockedDownText
    }


  $cbStart=strpos($lockedDownText, '[cb]');             
  $cbEnd=strpos($lockedDownText, '[/cb]', $cbStart); 
  
  // If has cb tag
  if($cbStart!==false)
    {
    $wpl_cbText=substr($lockedDownText, $cbStart+strlen('[cb]'), $cbEnd-$cbStart-strlen('[/cb]')+1); // extract cb text
    $wpl_cbText=trim($wpl_cbText);
    $lockedDownText=substr($lockedDownText, 0, $cbStart) . substr($lockedDownText, $cbEnd+strlen('[/cb]'), strlen($lockedDownText)); // strip cb text from lockedDownText
    }

  if($wpl_debugMode)
    {
    if($wpl_stealthDebug) echo "\n<!--";
    
    //echo "\n".'<li>Teaser="'. $wpl_teaseText . '"';
    echo "\n".'<li>Button url="'. $wpl_buttonUrl . '"';
    //echo "\n".'<li>Template="'. $wpl_lockdownTemplate . '"';
    echo "\n".'<li>Allowing amember product ids="'. $wpl_amemberText . '"';
    echo "\n".'<li>Allowing wordpress userlevels="'. $wpl_userlevelText . '"';
    echo "\n".'<li>Allowing clickbank products ="'. $cb . '"';
    echo "\n".'<li>Incremental title="'. $wpl_incrTitle . '"';
    
    if($wpl_stealthDebug) echo "\n-->";
    }

  global $current_user, $user_ID;
  
  $userID=$current_user->ID;
  
  // see if they should have access
  if($userID==0)
    $userID=$user_ID;
    
  // not logged in
  if($userID==0)
    {
    if($wpl_debugMode)
      {
      if($wpl_stealthDebug) echo "\n<!--";
      echo "\n".'<p><b style="color: #d00">Not allowing access because user is not logged in</b></p>';
      if($wpl_stealthDebug) echo "\n-->";
      }
      
    return onDenyAccess($wpl_lockdownTemplate, $freeContent, $wpl_teaseText, $wpl_buttonText, $wpl_buttonUrl);
    }

  // if they're logged in, make sure they're the right type of login
  global $userdata, $user_login, $wpdb;
  get_currentuserinfo(); // populates $user_login, see wp-includes/user.php:setup_userdata()
  
  if($user_login)
    if($wpl_debugMode)
      {
      if($wpl_stealthDebug) echo "\n<!--";
      echo "\n".'<li>Login="'. $user_login . '"';
      if($wpl_stealthDebug) echo "\n-->";
      }

  global $comingSoon;
  $comingSoon=false;
  
  if(allowAmember($wpl_amemberText, $wpl_debugMode, $wpl_stealthDebug))
    $allow=true;
  else if(allowUserlevel($wpl_userlevelText, $userdata->user_level, $wpl_debugMode, $wpl_stealthDebug))
    $allow=true;
  else if(allowCbProduct($wpl_cbText, $userID, $wpl_debugMode, $wpl_stealthDebug))
    $allow=true;
  
  if($allow)
    return onAllowAccess($freeContent, $lockedDownText, $endContent);
  
  if($comingSoon)
    return onComingSoon($wpl_comingSoonTemplate, $freeContent, $wpl_incrTitle);
  
  return onDenyAccess($wpl_lockdownTemplate, $freeContent, $wpl_teaseText, $wpl_buttonText, $wpl_buttonUrl);
  }

include_once('pro.php');

function allowUserlevel($wpl_userlevelText, $userLevel, $wpl_debugMode, $wpl_stealthDebug)
  {
  // see if we're restricting access based on wordpress userlevel
  if($wpl_userlevelText=='')
    return false;
    
  $userLevels=preg_split("/[\s,_]+/", $wpl_userlevelText);
  
  $allow=false;
  
  foreach($userLevels as $level)
    {
    /*if($userLevel>=intval($level))
      {
      if($wpl_debugMode)
        {
        if($wpl_stealthDebug) echo "\n<!--";
        echo "\n".'<p><b style="color: #d00">Allowing access because userlevel = ' . $userLevel . ' is greater than or equal to ' . intval($level).  '</b></p>';
        if($wpl_stealthDebug) echo "\n-->";
        }
      
      $allow=true;
      break;
      }*/

    //*
    if($level{0}=='>')
      {
      if($level{1}=='=') // >=
        {
        $level=substr($level, 2, strlen($level));
        
        if($userLevel>=intval($level))
          {
          if($wpl_debugMode)
            {
            if($wpl_stealthDebug) echo "\n<!--";
            echo "\n".'<p><b style="color: #d00">Allowing access because userlevel = ' . $userLevel . ' which is greater than or equal to ' . intval($level).  '</b></p>';
            if($wpl_stealthDebug) echo "\n-->";
            }
          
          $allow=true;
          break;
          }
        }
      else  // >
        {
        $level=substr($level, 1, strlen($level));
        
        if($userLevel>intval($level))
          {
          if($wpl_debugMode)
            {
            if($wpl_stealthDebug) echo "\n<!--";
            echo "\n".'<p><b style="color: #d00">Allowing access because userlevel = ' . $userLevel . ' which is greater than ' . intval($level).  '</b></p>';
            if($wpl_stealthDebug) echo "\n-->";
            }

          $allow=true;
          break;
          }
        }
      }
    else  // =
      {
      if($userLevel==intval($level))
        {
        if($wpl_debugMode)
          {
          if($wpl_stealthDebug) echo "\n<!--";
          echo "\n".'<p><b style="color: #d00">Allowing access because userlevel = ' . $userLevel . ' which is equal to ' . intval($level).  '</b></p>';
          if($wpl_stealthDebug) echo "\n-->";
          }

        $allow=true;
        break;
        }
      }
    //*/
    }

  if(!$allow)
    {
    if($wpl_debugMode)
      {
      if($wpl_stealthDebug) echo "\n<!--";
      echo "\n".'<p><b style="color: #d00">Not allowing access because no userlevel rules allowed access</b></p>';
      if($wpl_stealthDebug) echo "\n-->";
      }
    
    return false;
    }
  else
    return true;
  }

function onAllowAccess($freeContent, $lockedDownText, $endContent)
  {
  return trim($freeContent . $lockedDownText . $endContent);
  }

function onComingSoon($comingSoonTemplate, $freeContent, $wpl_incrTitle)
  {
  $pattern = array(
    '/%freeContent%/',
    '/%incrTitle%/');
  
  $replace = array(
    $freeContent,
    $wpl_incrTitle);
        
  return preg_replace($pattern, $replace, $comingSoonTemplate);
  }

function onDenyAccess($wpl_lockdownTemplate, $freeContent, $tease, $wpl_buttonText, $wpl_buttonUrl)
  {
  $pattern = array(
    '/%freeContent%/',
    '/%teaser%/',
    '/%url%/',
    '/%buttonText%/');
  
  $replace = array(
    $freeContent,
    $tease,
    $wpl_buttonUrl,
    $wpl_buttonText);
        
  return preg_replace($pattern, $replace, $wpl_lockdownTemplate);
  }

// functions for editing clickbank products the user has purchased
class custom_user_meta
  {
  function custom_user_meta()
    {
    if(is_admin() && current_user_can('create_users'))
      {
      add_action('show_user_profile', array
        (
        &$this,
        'action_show_user_profile'
        ));

      add_action('edit_user_profile', array
        (
        &$this,
        'action_show_user_profile'
        ));

      add_action('personal_options_update', array
        (
        &$this,
        'action_process_option_update'
        ));

      add_action('edit_user_profile_update', array
        (
        &$this,
        'action_process_option_update'
        ));
      }
    }

  function action_show_user_profile()
    {
    global $wpdb, $user_id;
    //$boughtProductsMeta=get_the_author_meta('cbProducts', $user->ID)
    $boughtProductsMeta=$wpdb->get_var($wpdb->prepare("SELECT meta_value FROM $wpdb->usermeta WHERE user_id = %d AND meta_key = %s", $user_id, 'cbProducts'));

    $boughtProductsMeta=str_replace('_', ' ', $boughtProductsMeta);

?>
    <h3><?php _e('Wordpress Lockdown') ?></h3>

    <table class = "form-table">
      <tr>
        <th>
          <label for = "cbProducts">Purchased Clickbank Product IDs</label>
        </th>

        <td>
          <input type = "text" name = "cbProducts" id = "cbProducts"
            value = "<?php echo esc_attr($boughtProductsMeta); ?>" />
          <br>(Separate multiple IDs with space such as 23 71 1)
        </td>
      </tr>
    </table>
<?php
    }

  function action_process_option_update()
    {
    global $user_id;
    
    $str=isset($_POST['cbProducts']) ? $_POST['cbProducts'] : '';
    
    $str=str_replace(' ', '_', $str);
    
    update_usermeta($user_id, 'cbProducts', $str);
    }
  }

/* Initialise */
add_action('plugins_loaded',
  create_function('', 'global $custom_user_meta_instance; $custom_user_meta_instance = new custom_user_meta();'));
?>